# Welcome to gingado!
> A machine learning library for economics and finance


`gingado` seeks to facilitate the use of machine learning in economic and finance use cases, while promoting good practices. `gingado` aims to be suitable for beginners and advanced users alike.

## Overview

`gingado` is a free, open source library built around three main functionalities:
* **data augmentation**, to add more data from official sources, improving the machine models being trained by the user;
* **automatic benchmark model**, to enable the user to assess their models against a reasonably well-performant model; and
* **support for model documentation**, to embed documentation and ethical considerations in the model development phase.

Each of these functionalities builds on top of the previous one. They can be used on a stand-alone basis, together, or even as part of a larger pipeline from data input to model training to documentation!

## Design principles

The choices made during development of `gingado` derive from the following principles, in no particular order:
* *lowering the barrier to use machine learning* can help more economists familiarise themselves with these techniques and use them when appopriate
* *offering compatibility with other existing software that is consolidated by wide practice* benefits users and should be promoted as much as possible
* *promoting good practices* such as documenting ethical considerations and benchmarking models as part of machine learning development will help embed these habits in economists

## Presentations, talks, papers

The material supporting public communication about `gingado` (ie, slide decks, papers) is kept in [this dedicated repository](https://github.com/dkgaraujo/gingado_comms). Interested users are welcome to visit the repository and comment on the drafts or slide decks, preferably by opening an [issue](https://github.com/dkgaraujo/gingado_comms/issues). I also store in this repository suggestions I receive as issues, so users can see what others commented (anonymously unless requested) and comment along as well!

## Install

To install `gingado`, simply run the following code on the terminal:

`$ pip install gingado`
